## iqtree 1.3.11.1+dfsg

=== CMakeLists.txt ===
##################################################################
# IQ-TREE cmake build definition
# Copyright (c) 2012-2015 Bui Quang Minh, Lam Tung Nguyen
##################################################################

# Windows example usages:
#------------------------
# cmake -G "Visual Studio 12" <source_dir>			(32-bit version, compiled with MSVC)
# cmake -G "Visual Studio 12 Win64" <source_dir>	(64-bit version, compiled with MSVC)
# cmake -G "Visual Studio 12 Win64" -T "Intel C++ Compiler XE 15.0" <source_dir>		(64-bit version, compiled with ICC)
# cmake -G "MinGW Makefiles" <source_dir> (TDM-GCC)
# cmake -G "Unix Makefiles" -DCMAKE_C_COMPILER=clang -DCMAKE_CXX_COMPILER=clang++ -DCMAKE_MAKE_PROGRAM=mingw32-make <source_dir> (TDM-GCC and clang)

# Linux example usages:
#----------------------
# cmake <source_dir>						   (sequential version)
# cmake -DIQTREE_FLAGS="omp" <source_dir>      (OpenMP version)
# cmake -DIQTREE_FLAGS="m32" <source_dir>      (32-bit sequential version)
# cmake -DIQTREE_FLAGS="m32 omp" <source_dir>  (32-bit OpenMP version)
#

# Mac OSX example usages:
#------------------------
# cmake -DCMAKE_C_COMPILER=clang -DCMAKE_CXX_COMPILER=clang++ <source_dir>							(sequential version)
#
# To build OpenMP version one needs to download Clang version 3.7 or later (as of November 2015) 
# Then assuming clang3.7 and clang++3.7 are the newly built compilers, then:
# cmake -DCMAKE_C_COMPILER=clang3.7 -DCMAKE_CXX_COMPILER=clang++3.7 -DIQTREE_FLAGS="omp" <source_dir>		(OpenMP version)
#


# Compile OpenMP version: cmake -DIQTREE_FLAGS=omp ....
# Compile 32-bit version: cmake -DIQTREE_FLAGS=m32 ....
# Compile static version: cmake -DIQTREE_FLAGS=static ....
# Compile static OpenMP version: cmake -DIQTREE_FLAGS="omp static" ....

#NOTE: Static linking with clang windows: make a symlink libgcc_eh.a to libgcc.a (administrator required)
# C:\TDM-GCC-64\lib\gcc\x86_64-w64-mingw32\5.1.0>mklink libgcc_eh.a libgcc.a

cmake_minimum_required(VERSION 2.8)
set(CMAKE_LEGACY_CYGWIN_WIN32 0)

project(iqtree)
add_definitions(-DIQ_TREE)
# The version number.
set (iqtree_VERSION_MAJOR 1)
set (iqtree_VERSION_MINOR 3)
set (iqtree_VERSION_PATCH "11.1") 

set(BUILD_SHARED_LIBS OFF)

message("IQ-TREE flags : ${IQTREE_FLAGS}")

if (NOT CMAKE_BUILD_TYPE) 
	set(CMAKE_BUILD_TYPE "Release")
endif()

if (CMAKE_BUILD_TYPE STREQUAL "Release") 
	message("Builde mode   : Release")
endif()

include_directories("${PROJECT_SOURCE_DIR}")


##################################################################
# Detect target platforms
##################################################################
if (WIN32)
	message("Target OS     : Windows")
	# build as static binary to run on most machines
    if (IQTREE_FLAGS MATCHES "static")
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static")
    endif()
    SET(CMAKE_FIND_LIBRARY_SUFFIXES .lib .a ${CMAKE_FIND_LIBRARY_SUFFIXES})
    add_definitions(-DWIN32)
elseif (APPLE) 
	message("Target OS     : Mac OS X")
	# to be compatible back to Mac OS X 10.6
	if (IQTREE_FLAGS MATCHES "oldmac") 
		add_definitions("-mmacosx-version-min=10.5") 
		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -mmacosx-version-min=10.5")
	else()
		add_definitions("-mmacosx-version-min=10.6") 
		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -mmacosx-version-min=10.6")
	endif()
    SET(CMAKE_FIND_LIBRARY_SUFFIXES .a ${CMAKE_FIND_LIBRARY_SUFFIXES})
elseif (UNIX) 
	message("Target OS     : Unix")
	# build as static binary to run on most machines
    if (NOT IQTREE_FLAGS MATCHES "static")
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -rdynamic")
    else()
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static")
    endif()
else()
	# Note that IQ-TREE has NOT been tested on other platforms
	message("Target OS     : Unknown and untested yet")
endif()

##################################################################
# Setup compiler, currently supported GCC, CLANG, MSVC, and ICC
##################################################################

set(GCC "FALSE")   #  GNU compiler
set(CLANG "FALSE") # Clang compiler
set(ICC "FALSE")   # Intel compiler
set(VCC "FALSE")   # MS Visual C Compiler, note that it is different from MSVC variable

if (CMAKE_COMPILER_IS_GNUCXX) 	
	message("Compiler      : GNU Compiler (gcc)")
	set(GCC "TRUE")
#	set(COMBINED_FLAGS "-Wall -Wno-unused-function -Wno-sign-compare -pedantic -D_GNU_SOURCE -fms-extensions -Wno-deprecated")
#	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++98")
	set(CMAKE_CXX_FLAGS_RELEASE "-O3 -g")
	set(CMAKE_C_FLAGS_RELEASE "-O3 -g")
elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
	message("Compiler      : Clang")
	set(CLANG "TRUE")
#	set(COMBINED_FLAGS "-Wall -Wno-unused-function -Wno-sign-compare -pedantic -D_GNU_SOURCE -Wno-nested-anon-types")
	set(CMAKE_CXX_FLAGS_RELEASE "-O3")
	set(CMAKE_C_FLAGS_RELEASE "-O3")	
elseif (CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
	set(VCC "TRUE")
	message("Compiler      : MS Visual C++ Compiler")
elseif (CMAKE_CXX_COMPILER_ID MATCHES "Intel")
	message("Compiler      : Intel C++ Compiler (icc)")
	set(ICC "TRUE")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /Qstd=c99")
else()
	message("Compiler      : Unknown and untested yet")
endif()

set(EXE_SUFFIX "")

if (MSVC) 
	# MS Visual Studio environment
	message("Exporting MS Visual Studio projects...")
	add_definitions(/MP) # enable multi-processor compilation
	if (CMAKE_BUILD_TYPE STREQUAL "Release")
		add_definitions(/Ot /Oi)
		if (VCC)
			add_definitions(/O2)
		elseif (ICC)
			add_definitions(/O3)
		endif()
	endif()
endif()



##################################################################
# Configure PLL build
##################################################################
if (IQTREE_FLAGS MATCHES "pll")
	add_definitions(-DUSING_PLL)
	set(EXE_SUFFIX "${EXE_SUFFIX}-pll")
endif()

##################################################################
# detect 32 or 64 bit binary
##################################################################
set (BINARY32 "FALSE")
if(CMAKE_SIZEOF_VOID_P EQUAL 4 OR IQTREE_FLAGS MATCHES "m32")
	set(BINARY32 "TRUE")
	message("Target binary : 32-bit")
	if (CMAKE_GENERATOR MATCHES "Win64")
		error("Both 32-bit and 64-bit mode cannot be specified")
	endif()
	SET(EXE_SUFFIX "${EXE_SUFFIX}32")
	if (GCC OR CLANG) 
		set(COMBINED_FLAGS "${COMBINED_FLAGS} -m32")
  	endif()
    add_definitions(-DBINARY32)
else()
	message("Target binary : 64-bit")
endif()

if(IQTREE_FLAGS MATCHES "novx") 
    add_definitions(-D__NOAVX__)
endif()

##################################################################
# configure OpenMP/PThreads compilation
# change the executable name if compiled for OpenMP parallel version
##################################################################
if (IQTREE_FLAGS MATCHES "omp")
	message("Parallel      : OpenMP/PThreads")
	SET(EXE_SUFFIX "${EXE_SUFFIX}-omp")	
	add_definitions(-D_USE_PTHREADS)
	if (MSVC) 
		add_definitions(/MT)
	endif()
	
	if (VCC) 
  		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /openmp")
  		include_directories("${PROJECT_SOURCE_DIR}/pll") # for PThreads headers 
	elseif (ICC)
  		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Qopenmp")
  		if (WIN32)
  			include_directories("${PROJECT_SOURCE_DIR}/pll") # for PThreads headers
  		endif() 
  	elseif (GCC)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread")
  		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp")
  	elseif (CLANG) 
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread")
  		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp=libomp")
  	endif()
else()
	message("Parallel      : None")
endif()

##################################################################
# configure SSE/AVX/FMA instructions
##################################################################

SET(AVX_FLAGS "-D__AVX")
if (VCC) 
	set(AVX_FLAGS "${AVX_FLAGS} /arch:AVX")
elseif (CLANG)
	set(AVX_FLAGS "${AVX_FLAGS} -mavx")
elseif (GCC)
	set(AVX_FLAGS "${AVX_FLAGS} -mavx -fabi-version=0")
elseif (ICC) 
	if (WIN32)
		 set(AVX_FLAGS "${AVX_FLAGS} /arch:AVX")
	else()
		 set(AVX_FLAGS "${AVX_FLAGS} -mavx")
	endif()
endif()

SET(SSE_FLAGS "")
if (VCC)
	set(SSE_FLAGS "/arch:SSE2 -D__SSE3__")
elseif (GCC OR CLANG)
	set(SSE_FLAGS "-msse3")
elseif (ICC)
	if (WIN32)
		set(SSE_FLAGS "/arch:SSE3")
	else()
		set(SSE_FLAGS "-msse3")
	endif()
endif()

if (IQTREE_FLAGS MATCHES "fma") # AVX+FMA instruction set
 	message("Vectorization : AVX+FMA")
	add_definitions(-D__SSE3 -D__AVX) # define both SSE3 and AVX directive
	if (VCC)
		# Visual C++ has no /mfma flag!, FMA is only included in AVX2 
		set(COMBINED_FLAGS "${COMBINED_FLAGS} /arch:AVX2")
	elseif (CLANG)
		set(COMBINED_FLAGS "${COMBINED_FLAGS} -mavx -mfma")
	elseif (GCC)
		set(COMBINED_FLAGS "${COMBINED_FLAGS} -mavx -fabi-version=0 -mfma")
	elseif (ICC) 
		if (WIN32)
			 set(COMBINED_FLAGS "${COMBINED_FLAGS} /arch:AVX /Qfma")
		else()
			 set(COMBINED_FLAGS "${COMBINED_FLAGS} -mavx -mfma")
		endif()
	endif()

	SET(EXE_SUFFIX "${EXE_SUFFIX}-fma")

elseif (IQTREE_FLAGS MATCHES "avx") # AVX instruction set
 	message("Vectorization : AVX")
	add_definitions(-D__SSE3 -D__AVX) # define both SSE3 and AVX directive
	set(COMBINED_FLAGS "${COMBINED_FLAGS} ${AVX_FLAGS}")

	SET(EXE_SUFFIX "${EXE_SUFFIX}-avx")
else() #SSE intruction set
	message("Vectorization : SSE3")
	add_definitions(-D__SSE3)

endif()


##################################################################
# Setup compiler flags
##################################################################

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${COMBINED_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${COMBINED_FLAGS}")

if (CMAKE_BUILD_TYPE STREQUAL "Release")
	message("C flags    : ${CMAKE_C_FLAGS} ${CMAKE_C_FLAGS_RELEASE}") 
	message("CXX flags  : ${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_RELEASE}") 
endif()

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
	message("C flags    : ${CMAKE_C_FLAGS} ${CMAKE_C_FLAGS_DEBUG}") 
	message("CXX flags  : ${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_DEBUG}") 
endif()

set(CMAKE_CXX_FLAGS_PROFILE "-fno-inline-functions -fno-inline-functions-called-once -fno-optimize-sibling-calls -fno-default-inline -fno-inline -O0 -fno-omit-frame-pointer -pg")
set(CMAKE_C_FLAGS_PROFILE "-fno-inline-functions -fno-inline-functions-called-once -fno-optimize-sibling-calls -O0 -fno-omit-frame-pointer -pg")

if (GCC) 
	set(CMAKE_CXX_FLAGS_DEBUG "-O0 -g -fno-inline-functions -fno-inline-functions-called-once -fno-default-inline -fno-inline")
	set(CMAKE_C_FLAGS_DEBUG "-O0 -g -fno-inline-functions -fno-inline-functions-called-once -fno-default-inline -fno-inline")
	set(CMAKE_CXX_FLAGS_MEM "-g -O1")
	set(CMAKE_C_FLAGS_MEM "-g -O1")
elseif (CLANG)
	set(CMAKE_CXX_FLAGS_DEBUG "-O0 -g -fno-inline-functions -fno-inline")
	set(CMAKE_C_FLAGS_DEBUG "-O0 -g -fno-inline-functions -fno-inline")
	set(CMAKE_CXX_FLAGS_MEM "-g -O1")
	set(CMAKE_C_FLAGS_MEM "-g -O1")
endif()

##################################################################
# check existence of a few basic functions
##################################################################
include (${CMAKE_ROOT}/Modules/CheckFunctionExists.cmake)
check_function_exists (gettimeofday HAVE_GETTIMEOFDAY)
check_function_exists (getrusage HAVE_GETRUSAGE)
check_function_exists (GlobalMemoryStatusEx HAVE_GLOBALMEMORYSTATUSEX)
check_function_exists (strndup HAVE_STRNDUP)

# configure a header file to pass some of the CMake settings
# to the source code
configure_file (
  "${PROJECT_SOURCE_DIR}/iqtree_config.h.in"
  "${PROJECT_BINARY_DIR}/iqtree_config.h"
  )

# add the binary tree to the search path for include files
# so that we will find iqtree_config.h
include_directories("${PROJECT_BINARY_DIR}")

#zlib will be detected for appearance
#include_directories("${PROJECT_BINARY_DIR}/zlib-1.2.7")


##################################################################
# subdirectories containing necessary libraries for the build 
##################################################################
add_subdirectory(pll)

=== vectorclass/CMakeLists.txt ===
add_library(vectorclass
instrset_detect.cpp
)

=== whtest/CMakeLists.txt ===

include_directories("${PROJECT_BINARY_DIR}")

add_library(whtest 
eigen.c  
eigen_sym.c  
random.c  
weisslambda.c  
weisslambda_sub.c  
whtest.c  
whtest_sub.c)

#install (TARGETS whtest DESTINATION bin)
#install (FILES  eigen.h  eigen_sym.h  random.h  tools.h  weisslambda_sub.h  whtest.h  whtest_sub.h DESTINATION include)

## iqtree 1.3.11.1%2Bdfsg

=== debian/control ===
Source: iqtree
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               libeigen3-dev,
               libsprng2-dev,
               zlib1g-dev,
               help2man,
               time
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/iqtree.git
Vcs-Git: git://anonscm.debian.org/debian-med/iqtree.git
Homepage: http://www.cibiv.at/software/iqtree/

Package: iqtree
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: efficient phylogenetic software by maximum likelihood
 IQ-TREE is a very efficient maximum likelihood phylogenetic software
 with following key features among others:
 .
  * A novel fast and effective stochastic algorithm to estimate maximum
    likelihood trees. IQ-TREE outperforms both RAxML and PhyML in terms
    of likelihood while requiring similar amount of computing time (see
    Nguyen et al., 2015)
  * An ultrafast bootstrap approximation to assess branch supports (see
    Minh et al., 2013).
  * A wide range of substitution models for binary, DNA, protein, codon,
    and morphological alignments.
  * Ultrafast model selection for all data types, 10 to 100 times faster
    than jModelTest and ProtTest.
  * Finding best partition scheme like PartitionFinder.
  * Partitioned models with mixed data types for phylogenomic (multi-
    gene) alignments, allowing for separate, proportional, or joint
    branch lengths among genes.
  * Supporting the phylogenetic likelihod library (PLL) (see Flouri et
    al., 2014)

## iqtree 1.3.11.1+dfsg

=== debian/changelog ===
iqtree (1.3.11.1+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #798511)

 -- Andreas Tille <tille@debian.org>  Thu, 17 Dec 2015 17:13:25 +0100

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

pkg := $(shell dpkg-parsechangelog | sed -n 's/^Source: //p')
version=$(shell dpkg-parsechangelog -ldebian/changelog | grep Version: | cut -f2 -d' ' | cut -f1 -d- )
mandir=$(CURDIR)/debian/$(pkg)/usr/share/man/man1/
tmpompdir=$(CURDIR)/debian/tmp-omp/usr/bin

%:
	dh $@

# Build first with OMP multiprocessing
override_dh_auto_configure:
	dh_auto_configure -- -DIQTREE_FLAGS="omp"

override_dh_auto_build:
	dh_auto_build
	mkdir -p $(tmpompdir)
	cp -a `find $(CURDIR) -name iqtree-omp -type f -executable` $(tmpompdir)
	# build again without OMP
	dh_auto_clean
	dh_auto_configure
	dh_auto_build

override_dh_auto_install:
	dh_auto_install
	mv $(tmpompdir)/iqtree-omp debian/$(pkg)/usr/bin

override_dh_installexamples:
	dh_installexamples
	# remove example files in unusual dir
	rm -f debian/*/usr/models.nex
	rm -f debian/*/usr/example.[np][eh][xy]

override_dh_installman:
	mkdir -p $(mandir)
	help2man --no-info --no-discard-stderr --help-option="-h" \
	    --name='efficient phylogenetic software by maximum likelihood' \
	    --version-string="$(version)" $(CURDIR)/debian/$(pkg)/usr/bin/iqtree > $(mandir)/iqtree.1
	help2man --no-info --no-discard-stderr --help-option="-h" \
	    --name='efficient phylogenetic software by maximum likelihood (multiprocessor version)' \
	    --version-string="$(version)" $(CURDIR)/debian/$(pkg)/usr/bin/iqtree-omp > $(mandir)/iqtree-omp.1

override_dh_auto_test:
	# use only the first example for build time test to save time on autobuilders
#	if [ "`find $(CURDIR) -name iqtree -type f -executable`" = "" ] ; then \
#		iqtreeomp=`find $(CURDIR) -name iqtree-omp -type f -executable` ; \
#		ln -s iqtree-omp `dirname $$iqtreeomp`/iqtree ; \
#	fi
	sed '/ myprefix/,$$d' debian/Documents_source/example.sh > example.short
	echo 'time $(tmpompdir)/iqtree-omp -s example.phy -omp 2' >> example.short
	time sh example.short
	rm example.short

get-orig-source:
	uscan --verbose --force-download --repack --compression xz

=== debian/watch ===
version=3

opts="dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg" \
  https://github.com/Cibiv/IQ-TREE/releases .*/archive/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## iqtree 1.4.3+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -37,15 +37,15 @@
 #NOTE: Static linking with clang windows: make a symlink libgcc_eh.a to libgcc.a (administrator required)
 # C:\TDM-GCC-64\lib\gcc\x86_64-w64-mingw32\5.1.0>mklink libgcc_eh.a libgcc.a
 
-cmake_minimum_required(VERSION 2.8)
+cmake_minimum_required(VERSION 2.8.10 FATAL_ERROR)
 set(CMAKE_LEGACY_CYGWIN_WIN32 0)
 
 project(iqtree)
 add_definitions(-DIQ_TREE)
 # The version number.
 set (iqtree_VERSION_MAJOR 1)
-set (iqtree_VERSION_MINOR 3)
-set (iqtree_VERSION_PATCH "11.1") 
+set (iqtree_VERSION_MINOR 4)
+set (iqtree_VERSION_PATCH "3") 
 
 set(BUILD_SHARED_LIBS OFF)
 
@@ -113,6 +113,10 @@
 #	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++98")
 	set(CMAKE_CXX_FLAGS_RELEASE "-O3 -g")
 	set(CMAKE_C_FLAGS_RELEASE "-O3 -g")
+    # require at least gcc 4.6
+    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.6)
+        message(FATAL_ERROR "GCC version must be at least 4.6!")
+    endif()
 elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
 	message("Compiler      : Clang")
 	set(CLANG "TRUE")
@@ -331,7 +335,3 @@
 #include_directories("${PROJECT_BINARY_DIR}/zlib-1.2.7")
 
 
-##################################################################
-# subdirectories containing necessary libraries for the build 
-##################################################################
-add_subdirectory(pll)

=== debian/changelog ===
iqtree (1.4.3+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Mon, 15 Aug 2016 22:24:55 +0200

iqtree (1.4.2+dfsg-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version
  * Use repack,compression=xz in d/watch instead of adding get-orig-source to
    d/rules
  * Do not use -m32 and -msse3 flags
    Closes: #813436
  * Do not append 32 to binary name if build on 32bit architecture
    Closes: #813437
  * Restrict binary to intel architecture
    Closes: #813438
  * cme fix dpkg-control
  * hardening=+all

  [ Christian Seiler ]
  * debian/rules:
     - parallel build
     - use variants to more elegantly build serial and omp executable
     - fix build time test
  * debian/patches/sse.patch
     - fix PLL_BYTE_ALIGNMENT to work around pll bug
     - fix SSE patch to properly build on amd64 and i386

 -- Andreas Tille <tille@debian.org>  Wed, 29 Jun 2016 13:38:33 +0200

=== debian/control ===
--- 
+++ 
@@ -10,13 +10,13 @@
                zlib1g-dev,
                help2man,
                time
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/iqtree.git
-Vcs-Git: git://anonscm.debian.org/debian-med/iqtree.git
+Vcs-Git: https://anonscm.debian.org/git/debian-med/iqtree.git
 Homepage: http://www.cibiv.at/software/iqtree/
 
 Package: iqtree
-Architecture: any
+Architecture: amd64 hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: efficient phylogenetic software by maximum likelihood

=== debian/rules ===
--- 
+++ 
@@ -2,30 +2,36 @@
 
 # DH_VERBOSE := 1
 
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+
 pkg := $(shell dpkg-parsechangelog | sed -n 's/^Source: //p')
 version=$(shell dpkg-parsechangelog -ldebian/changelog | grep Version: | cut -f2 -d' ' | cut -f1 -d- )
 mandir=$(CURDIR)/debian/$(pkg)/usr/share/man/man1/
-tmpompdir=$(CURDIR)/debian/tmp-omp/usr/bin
 
 %:
-	dh $@
+	dh $@ --parallel
 
-# Build first with OMP multiprocessing
-override_dh_auto_configure:
-	dh_auto_configure -- -DIQTREE_FLAGS="omp"
+VARIANTS = omp serial
 
-override_dh_auto_build:
-	dh_auto_build
-	mkdir -p $(tmpompdir)
-	cp -a `find $(CURDIR) -name iqtree-omp -type f -executable` $(tmpompdir)
-	# build again without OMP
-	dh_auto_clean
-	dh_auto_configure
-	dh_auto_build
+override_dh_auto_configure: $(foreach variant,$(VARIANTS),dh_auto_configure_$(variant))
+override_dh_auto_build:     $(foreach variant,$(VARIANTS),dh_auto_build_$(variant))
+override_dh_auto_install:   $(foreach variant,$(VARIANTS),dh_auto_install_$(variant))
+override_dh_auto_clean:     $(foreach variant,$(VARIANTS),dh_auto_clean_$(variant))
 
-override_dh_auto_install:
-	dh_auto_install
-	mv $(tmpompdir)/iqtree-omp debian/$(pkg)/usr/bin
+dh_auto_configure_omp:
+	dh_auto_configure -Bbuild.omp -- -DIQTREE_FLAGS="omp"
+
+dh_auto_configure_serial:
+	dh_auto_configure -Bbuild.serial -- -DIQTREE_FLAGS=""
+
+dh_auto_build_%:
+	dh_auto_build -Bbuild.$(subst dh_auto_build_,,$@)
+
+dh_auto_install_%:
+	dh_auto_install -Bbuild.$(subst dh_auto_install_,,$@)
+
+dh_auto_clean_%:
+	dh_auto_clean -Bbuild.$(subst dh_auto_clean_,,$@)
 
 override_dh_installexamples:
 	dh_installexamples
@@ -49,9 +55,6 @@
 #		ln -s iqtree-omp `dirname $$iqtreeomp`/iqtree ; \
 #	fi
 	sed '/ myprefix/,$$d' debian/Documents_source/example.sh > example.short
-	echo 'time $(tmpompdir)/iqtree-omp -s example.phy -omp 2' >> example.short
+	echo 'time $(CURDIR)/build.omp/iqtree-omp -s example.phy -omp 2	-redo' >> example.short
 	time sh example.short
 	rm example.short
-
-get-orig-source:
-	uscan --verbose --force-download --repack --compression xz

=== debian/watch ===
version=3

opts="dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg,repack,compression=xz" \
  https://github.com/Cibiv/IQ-TREE/releases .*/archive/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## iqtree 1.5.3+dfsg

=== CMakeLists.txt ===
##################################################################
# IQ-TREE cmake build definition
# Copyright (c) 2012-2015 Bui Quang Minh, Lam-Tung Nguyen
##################################################################

# Windows example usages:
#------------------------
# cmake -G "Visual Studio 12" <source_dir>			(32-bit version, compiled with MSVC)
# cmake -G "Visual Studio 12 Win64" <source_dir>	(64-bit version, compiled with MSVC)
# cmake -G "Visual Studio 12 Win64" -T "Intel C++ Compiler XE 15.0" <source_dir>		(64-bit version, compiled with ICC)
# cmake -G "MinGW Makefiles" <source_dir> (TDM-GCC)
# cmake -G "Unix Makefiles" -DCMAKE_C_COMPILER=clang -DCMAKE_CXX_COMPILER=clang++ -DCMAKE_MAKE_PROGRAM=mingw32-make <source_dir> (TDM-GCC and clang)

# Linux example usages:
#----------------------
# cmake <source_dir>						   (sequential version)
# cmake -DIQTREE_FLAGS="omp" <source_dir>      (OpenMP version)
# cmake -DIQTREE_FLAGS="m32" <source_dir>      (32-bit sequential version)
# cmake -DIQTREE_FLAGS="m32 omp" <source_dir>  (32-bit OpenMP version)
#
# To compile with CLANG on Linux:
# export CC=/usr/bin/clang
# export CXX=/usr/bin/clang++
# Best practices for setting up CMAKE for diffrent compiler can be found here:
# http://stackoverflow.com/questions/7031126/switching-between-gcc-and-clang-llvm-using-cmake
#
# Mac OSX example usages:
#------------------------
# cmake -DCMAKE_C_COMPILER=clang -DCMAKE_CXX_COMPILER=clang++ <source_dir>							(sequential version)
#
# To build OpenMP version one needs to download Clang version 3.7 or later (as of November 2015)
# Then assuming clang3.7 and clang++3.7 are the newly built compilers, then:
# cmake -DCMAKE_C_COMPILER=clang3.7 -DCMAKE_CXX_COMPILER=clang++3.7 -DIQTREE_FLAGS="omp" <source_dir>		(OpenMP version)
#


# Compile OpenMP version: cmake -DIQTREE_FLAGS=omp ....
# Compile 32-bit version: cmake -DIQTREE_FLAGS=m32 ....
# Compile static version: cmake -DIQTREE_FLAGS=static ....
# Compile static OpenMP version: cmake -DIQTREE_FLAGS="omp static" ....

#NOTE: Static linking with clang windows: make a symlink libgcc_eh.a to libgcc.a (administrator required)
# C:\TDM-GCC-64\lib\gcc\x86_64-w64-mingw32\5.1.0>mklink libgcc_eh.a libgcc.a

cmake_minimum_required(VERSION 2.8.10 FATAL_ERROR)
set(CMAKE_LEGACY_CYGWIN_WIN32 0)

project(iqtree)
add_definitions(-DIQ_TREE)
# The version number.
set (iqtree_VERSION_MAJOR 1)
set (iqtree_VERSION_MINOR 5)
set (iqtree_VERSION_PATCH "3")

set(BUILD_SHARED_LIBS OFF)

if (CMAKE_C_COMPILER MATCHES "mpi")
    set(IQTREE_FLAGS "${IQTREE_FLAGS} mpi")
endif()

message("IQ-TREE flags : ${IQTREE_FLAGS}")

if (NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "Release")
endif()

if (CMAKE_BUILD_TYPE STREQUAL "Release")
	message("Builde mode   : Release")
endif()

if (CMAKE_GENERATOR MATCHES "Xcode")
    set(CMAKE_XCODE_ATTRIBUTE_DEBUG_INFORMATION_FORMAT "dwarf-with-dsym")
endif()

include_directories("${PROJECT_SOURCE_DIR}")

##################################################################
# Detect target platforms
##################################################################
if (WIN32)
	message("Target OS     : Windows")
	# build as static binary to run on most machines
    if (IQTREE_FLAGS MATCHES "static")
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static")
    endif()
    SET(CMAKE_FIND_LIBRARY_SUFFIXES .lib .a ${CMAKE_FIND_LIBRARY_SUFFIXES})
    add_definitions(-DWIN32)
elseif (APPLE)
	message("Target OS     : Mac OS X")
	# to be compatible back to Mac OS X 10.6
	if (IQTREE_FLAGS MATCHES "oldmac")
		add_definitions("-mmacosx-version-min=10.5")
		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -mmacosx-version-min=10.5")
	else()
		add_definitions("-mmacosx-version-min=10.6")
		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -mmacosx-version-min=10.6")
	endif()
    SET(CMAKE_FIND_LIBRARY_SUFFIXES .a ${CMAKE_FIND_LIBRARY_SUFFIXES})
elseif (UNIX)
	message("Target OS     : Unix")
	# build as static binary to run on most machines
    if (NOT IQTREE_FLAGS MATCHES "static")
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -rdynamic")
    else()
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static")
    endif()
else()
	# Note that IQ-TREE has NOT been tested on other platforms
	message("Target OS     : Unknown and untested yet")
endif()

##################################################################
# Setup compiler, currently supported GCC, CLANG, MSVC, and ICC
##################################################################

set(GCC "FALSE")   #  GNU compiler
set(CLANG "FALSE") # Clang compiler
set(ICC "FALSE")   # Intel compiler
set(VCC "FALSE")   # MS Visual C Compiler, note that it is different from MSVC variable
# using C++11 standard
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

if (CMAKE_COMPILER_IS_GNUCXX)
	message("Compiler      : GNU Compiler (gcc)")
	set(GCC "TRUE")
#	set(COMBINED_FLAGS "-Wall -Wno-unused-function -Wno-sign-compare -pedantic -D_GNU_SOURCE -fms-extensions -Wno-deprecated")
	set(CMAKE_CXX_FLAGS_RELEASE "-O3 -g")
	set(CMAKE_C_FLAGS_RELEASE "-O3 -g")
    # require at least gcc 4.8
    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.8)
        message(FATAL_ERROR "GCC version must be at least 4.8!")
    endif()
    if (WIN32)
        # disable AVX on Windows due to memory alignment
        set(IQTREE_FLAGS "${IQTREE_FLAGS} novx")
        message("WARNING: AVX is disabled on Windows as GCC does not properly suport memory alignment")
    endif()
elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
	message("Compiler      : Clang")
	set(CLANG "TRUE")
#	set(COMBINED_FLAGS "-Wall -Wno-unused-function -Wno-sign-compare -pedantic -D_GNU_SOURCE -Wno-nested-anon-types")
    #if (APPLE AND NOT CMAKE_BUILD_TYPE MATCHES "Debug")
    #    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
    #    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -stdlib=libc++")
    #endif()
	set(CMAKE_CXX_FLAGS_RELEASE "-O3")
	set(CMAKE_C_FLAGS_RELEASE "-O3")
elseif (CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
	set(VCC "TRUE")
	message("Compiler      : MS Visual C++ Compiler")
elseif (CMAKE_CXX_COMPILER_ID MATCHES "Intel")
	message("Compiler      : Intel C++ Compiler (icc)")
	set(ICC "TRUE")
    #set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /Qstd=c99")
else()
	message("Compiler      : Unknown and untested yet")
endif()

set(EXE_SUFFIX "")

if (MSVC)
	# MS Visual Studio environment
	message("Exporting MS Visual Studio projects...")
	add_definitions(/MP) # enable multi-processor compilation
	if (CMAKE_BUILD_TYPE STREQUAL "Release")
		add_definitions(/Ot /Oi)
		if (VCC)
			add_definitions(/O2)
		elseif (ICC)
            #add_definitions(/O3)
			add_definitions(/O3)
		endif()
	endif()
endif()

##################################################################
# configure MPI compilation
##################################################################

if (IQTREE_FLAGS MATCHES "mpi")
    add_definitions(-D_IQTREE_MPI)
    if (NOT CMAKE_CXX_COMPILER MATCHES "mpi")
        # if not using the MPI compiler wrapper, set own options manually 
        find_package(MPI REQUIRED)
        set(CMAKE_CXX_COMPILE_FLAGS "${CMAKE_CXX_COMPILE_FLAGS} ${MPI_CXX_COMPILE_FLAGS}")
        set(CMAKE_C_COMPILE_FLAGS "${CMAKE_C_COMPILE_FLAGS} ${MPI_C_COMPILE_FLAGS}")
        set(CMAKE_CXX_LINK_FLAGS "${CMAKE_CXX_LINK_FLAGS} ${MPI_CXX_LINK_FLAGS}")
        set(CMAKE_C_LINK_FLAGS "${CMAKE_C_LINK_FLAGS} ${MPI_C_LINK_FLAGS}")
        include_directories(${MPI_C_INCLUDE_PATH})
        include_directories(${MPI_CXX_INCLUDE_PATH})
    endif()
endif()


##################################################################
# Configure PLL build
##################################################################
if (IQTREE_FLAGS MATCHES "pll")
	add_definitions(-DUSING_PLL)
	set(EXE_SUFFIX "${EXE_SUFFIX}-pll")
endif()

##################################################################
# detect 32 or 64 bit binary
##################################################################
set (BINARY32 "FALSE")
if(CMAKE_SIZEOF_VOID_P EQUAL 4 OR IQTREE_FLAGS MATCHES "m32")
	set(BINARY32 "TRUE")
	message("Target binary : 32-bit")
	if (CMAKE_GENERATOR MATCHES "Win64")
		error("Both 32-bit and 64-bit mode cannot be specified")
	endif()
	#SET(EXE_SUFFIX "${EXE_SUFFIX}32")
	if (GCC OR CLANG) 
		set(COMBINED_FLAGS "${COMBINED_FLAGS} -m32")
  	endif()
    add_definitions(-DBINARY32)
else()
	message("Target binary : 64-bit")
endif()

if(IQTREE_FLAGS MATCHES "novx")
    add_definitions(-D__NOAVX__)
endif()

##################################################################
# configure OpenMP/PThreads compilation
# change the executable name if compiled for OpenMP parallel version
##################################################################
if (IQTREE_FLAGS MATCHES "omp")
	message("OpenMP        : Yes")
	SET(EXE_SUFFIX "${EXE_SUFFIX}-omp")
	add_definitions(-D_USE_PTHREADS)
	if (MSVC)
		add_definitions(/MT)
	endif()

	if (VCC)
  		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /openmp")
  		include_directories("${PROJECT_SOURCE_DIR}/pll") # for PThreads headers
	elseif (ICC)
  		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Qopenmp")
  		if (WIN32)
  			include_directories("${PROJECT_SOURCE_DIR}/pll") # for PThreads headers
  		endif()
  	elseif (GCC)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread")
  		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp -pthread")
  	elseif (CLANG)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread")
  		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp=libomp")
  	endif()
else()
	message("OpenMP        : NONE")
endif()


if (IQTREE_FLAGS MATCHES "mpi")
	message("MPI           : Yes")
	SET(EXE_SUFFIX "${EXE_SUFFIX}-mpi")
else()
	message("MPI           : NONE")
endif()

##################################################################
# configure SSE/AVX/FMA instructions
##################################################################

SET(AVX_FLAGS "-D__SSE3 -D__AVX")
if (VCC) 
	set(AVX_FLAGS "${AVX_FLAGS} /arch:AVX")
elseif (CLANG)
	set(AVX_FLAGS "${AVX_FLAGS} -mavx")
elseif (GCC)
	set(AVX_FLAGS "${AVX_FLAGS} -mavx -fabi-version=0")
elseif (ICC)
	if (WIN32)
		 set(AVX_FLAGS "${AVX_FLAGS} /arch:AVX")
	else()
		 set(AVX_FLAGS "${AVX_FLAGS} -mavx")
	endif()
endif()

SET(SSE_FLAGS "-D__SSE3")
if (VCC)
	set(SSE_FLAGS "${SSE_FLAGS} /arch:SSE2 -D__SSE3__")
elseif (GCC OR CLANG)
	set(SSE_FLAGS "${SSE_FLAGS} -msse3")
elseif (ICC)
	if (WIN32)
		set(SSE_FLAGS "${SSE_FLAGS} /arch:SSE3")
	else()
		set(SSE_FLAGS "${SSE_FLAGS} -msse3")
	endif()
endif()

SET(FMA_FLAGS "-D__SSE3 -D__AVX")
if (VCC) 
	set(FMA_FLAGS "${FMA_FLAGS} /arch:AVX2")
elseif (CLANG)
	set(FMA_FLAGS "${FMA_FLAGS} -mavx -mfma")
elseif (GCC)
	set(FMA_FLAGS "${FMA_FLAGS} -mavx -fabi-version=0 -mfma")
elseif (ICC) 
	if (WIN32)
		 set(FMA_FLAGS "${FMA_FLAGS} /arch:AVX /Qfma")
	else()
		 set(FMA_FLAGS "${FMA_FLAGS} -march=core-avx2")
	endif()
endif()

SET(AVX512_FLAGS "-D__SSE3 -D__AVX")
if (VCC)
    message("AVX512 not available in Visual C++")
	#set(AVX512_FLAGS "${AVX512_FLAGS} /arch:AVX512")
elseif (CLANG)
	set(AVX512_FLAGS "${AVX512_FLAGS} -mavx512f -mfma")
elseif (GCC)
	set(AVX512_FLAGS "${AVX512_FLAGS} -mavx512f -mfma")
elseif (ICC) 
	if (WIN32)
		 set(AVX512_FLAGS "${AVX512_FLAGS} /arch:MIC-AVX512 /Qfma")
	else()
		 set(AVX512_FLAGS "${AVX512_FLAGS} -xMIC-AVX512 -mfma")
	endif()
endif()


# further flag to improve performance

if (IQTREE_FLAGS MATCHES "fma") # AVX+FMA instruction set
 	message("Vectorization : AVX+FMA")
	add_definitions(-D__SSE3 -D__AVX) # define both SSE3 and AVX directive
    set(COMBINED_FLAGS "${COMBINED_FLAGS} ${FMA_FLAGS}")
	#SET(EXE_SUFFIX "${EXE_SUFFIX}-fma")
elseif (IQTREE_FLAGS MATCHES "avx") # AVX instruction set
 	message("Vectorization : AVX")
	add_definitions(-D__SSE3 -D__AVX) # define both SSE3 and AVX directive
	set(COMBINED_FLAGS "${COMBINED_FLAGS} ${AVX_FLAGS}")
	#SET(EXE_SUFFIX "${EXE_SUFFIX}-avx")
elseif (NOT IQTREE_FLAGS MATCHES "nosse") #SSE intruction set

=== model/CMakeLists.txt ===
add_library(model
modelgtr.cpp
modelbin.cpp
modeldna.cpp
modelfactory.cpp
modelnonrev.cpp
modelprotein.cpp
modelset.cpp
modelsubst.cpp
partitionmodel.cpp
rategamma.cpp
rategammainvar.cpp
rateheterogeneity.cpp
rateinvar.cpp
ratemeyerdiscrete.cpp
ratemeyerhaeseler.cpp
ratekategory.cpp
ratefree.cpp
ratefreeinvar.cpp
modelcodon.cpp
modelmorphology.cpp
modelmixture.cpp
)

=== pll/CMakeLists.txt ===
#set( CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -Wall -msse3 -DRAXML_USE_LLALLOC -D_USE_PTHREADS -D_OPTIMIZED_FUNCTIONS -D__SIM_SSE3 -fno-builtin" )

#add_executable( raxml_light axml.c  optimizeModel.c trash.c searchAlgo.c topologies.c treeIO.c models.c evaluatePartialGenericSpecial.c evaluateGenericSpecial.c newviewGenericSpecial.c makenewzGenericSpecial.c bipartitionList.c restartHashTable.c fastDNAparsimony.c randomTree.c lockless_allocator/ll_alloc.c mem_alloc.c recom.c)

#target_link_libraries( raxml_light m pthread )

if (NOT BINARY32 AND NOT IQTREE_FLAGS MATCHES "novx")
add_library(pllavx 
	avxLikelihood.c)
endif()

if (IQTREE_FLAGS MATCHES "omp")
add_library(pll 
  alignment.c
  bipartitionList.c
  evaluateGenericSpecial.c
  evaluatePartialGenericSpecial.c
  fastDNAparsimony.c
  hardware.c
  hash.c
  lexer.c
  makenewzGenericSpecial.c
  models.c
  newick.c
  newviewGenericSpecial.c
  genericParallelization.c
  optimizeModel.c
  parsePartition.c
  queue.c
  randomTree.c
  recom.c
  restartHashTable.c
  searchAlgo.c
  ssort.c
  stack.c
  topologies.c
  trash.c
  treeIO.c
  utils.c)
else()
add_library(pll 
  alignment.c
  bipartitionList.c
  evaluateGenericSpecial.c
  evaluatePartialGenericSpecial.c
  fastDNAparsimony.c
  hardware.c
  hash.c
  lexer.c
  makenewzGenericSpecial.c
  models.c
  newick.c
  newviewGenericSpecial.c
  optimizeModel.c
  parsePartition.c
  queue.c
  randomTree.c
  recom.c
  restartHashTable.c
  searchAlgo.c
  ssort.c
  stack.c
  topologies.c
  trash.c
  treeIO.c
  utils.c)
endif()

=== debian/changelog ===
iqtree (1.5.3+dfsg-2) unstable; urgency=medium

  [ Roger Shimizu ]
  * debian/rules:
    - Run dh_auto_test only if CPUs >= 2 (Closes: #854500).

  [ Andreas Tille ]
  * Implement remarks given by upstream
    (https://github.com/Cibiv/IQ-TREE/issues/17)

 -- Andreas Tille <tille@debian.org>  Sat, 11 Feb 2017 12:52:45 +0100

iqtree (1.5.3+dfsg-1) unstable; urgency=medium

  * New upstream version
  * debhelper 10
  * d/watch: version=4

 -- Andreas Tille <tille@debian.org>  Thu, 19 Jan 2017 08:36:11 +0100

iqtree (1.5.2+dfsg-1) unstable; urgency=medium

  * New upstream version 1.5.2+dfsg (Closes: #846958)
  * Enable build of MPI-parallelised executable

 -- Kevin Murray <kdmfoss@gmail.com>  Sun, 04 Dec 2016 11:25:38 +1100

iqtree (1.4.4+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Disable sse patch

 -- Andreas Tille <tille@debian.org>  Fri, 09 Sep 2016 11:07:13 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,14 @@
 Source: iqtree
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Andreas Tille <tille@debian.org>
+Uploaders: Andreas Tille <tille@debian.org>,
+           Kevin Murray <kdmfoss@gmail.com>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 10),
                cmake,
                libeigen3-dev,
                libsprng2-dev,
+               mpi-default-dev,
                zlib1g-dev,
                help2man,
                time

=== debian/rules ===
--- 
+++ 
@@ -9,14 +9,17 @@
 mandir=$(CURDIR)/debian/$(pkg)/usr/share/man/man1/
 
 %:
-	dh $@ --parallel
+	dh $@
 
-VARIANTS = omp serial
+VARIANTS = omp serial mpi
 
 override_dh_auto_configure: $(foreach variant,$(VARIANTS),dh_auto_configure_$(variant))
 override_dh_auto_build:     $(foreach variant,$(VARIANTS),dh_auto_build_$(variant))
 override_dh_auto_install:   $(foreach variant,$(VARIANTS),dh_auto_install_$(variant))
 override_dh_auto_clean:     $(foreach variant,$(VARIANTS),dh_auto_clean_$(variant))
+
+dh_auto_configure_mpi:
+	dh_auto_configure -Bbuild.mpi -- -DIQTREE_FLAGS="mpi"
 
 dh_auto_configure_omp:
 	dh_auto_configure -Bbuild.omp -- -DIQTREE_FLAGS="omp"
@@ -47,6 +50,9 @@
 	help2man --no-info --no-discard-stderr --help-option="-h" \
 	    --name='efficient phylogenetic software by maximum likelihood (multiprocessor version)' \
 	    --version-string="$(version)" $(CURDIR)/debian/$(pkg)/usr/bin/iqtree-omp > $(mandir)/iqtree-omp.1
+	help2man --no-info --no-discard-stderr --help-option="-h" \
+	    --name='efficient phylogenetic software by maximum likelihood (multiprocessor version)' \
+	    --version-string="$(version)" $(CURDIR)/debian/$(pkg)/usr/bin/iqtree-mpi > $(mandir)/iqtree-mpi.1
 
 override_dh_auto_test:
 	# use only the first example for build time test to save time on autobuilders
@@ -54,7 +60,9 @@
 #		iqtreeomp=`find $(CURDIR) -name iqtree-omp -type f -executable` ; \
 #		ln -s iqtree-omp `dirname $$iqtreeomp`/iqtree ; \
 #	fi
+ifneq ($(shell nproc), 1)
 	sed '/ myprefix/,$$d' debian/Documents_source/example.sh > example.short
 	echo 'time $(CURDIR)/build.omp/iqtree-omp -s example.phy -omp 2	-redo' >> example.short
 	time sh example.short
 	rm example.short
+endif

## iqtree 1.5.5+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -50,11 +50,11 @@
 # The version number.
 set (iqtree_VERSION_MAJOR 1)
 set (iqtree_VERSION_MINOR 5)
-set (iqtree_VERSION_PATCH "3")
+set (iqtree_VERSION_PATCH "5")
 
 set(BUILD_SHARED_LIBS OFF)
 
-if (CMAKE_C_COMPILER MATCHES "mpi")
+if (CMAKE_C_COMPILER MATCHES "mpic")
     set(IQTREE_FLAGS "${IQTREE_FLAGS} mpi")
 endif()
 
@@ -87,13 +87,13 @@
     add_definitions(-DWIN32)
 elseif (APPLE)
 	message("Target OS     : Mac OS X")
-	# to be compatible back to Mac OS X 10.6
+	# to be compatible back to Mac OS X 10.7
 	if (IQTREE_FLAGS MATCHES "oldmac")
 		add_definitions("-mmacosx-version-min=10.5")
 		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -mmacosx-version-min=10.5")
 	else()
-		add_definitions("-mmacosx-version-min=10.6")
-		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -mmacosx-version-min=10.6")
+		add_definitions("-mmacosx-version-min=10.7")
+		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -mmacosx-version-min=10.7")
 	endif()
     SET(CMAKE_FIND_LIBRARY_SUFFIXES .a ${CMAKE_FIND_LIBRARY_SUFFIXES})
 elseif (UNIX)
@@ -124,8 +124,13 @@
 	message("Compiler      : GNU Compiler (gcc)")
 	set(GCC "TRUE")
 #	set(COMBINED_FLAGS "-Wall -Wno-unused-function -Wno-sign-compare -pedantic -D_GNU_SOURCE -fms-extensions -Wno-deprecated")
-	set(CMAKE_CXX_FLAGS_RELEASE "-O3 -g")
-	set(CMAKE_C_FLAGS_RELEASE "-O3 -g")
+	set(CMAKE_CXX_FLAGS_RELEASE "-O3 -g -ffunction-sections -fdata-sections")
+	set(CMAKE_C_FLAGS_RELEASE "-O3 -g -ffunction-sections -fdata-sections")
+    if (APPLE)
+        set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} -Wl,-dead_strip")
+    else()
+        set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} -Wl,--gc-sections")
+    endif()
     # require at least gcc 4.8
     if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.8)
         message(FATAL_ERROR "GCC version must be at least 4.8!")
@@ -139,12 +144,23 @@
 	message("Compiler      : Clang")
 	set(CLANG "TRUE")
 #	set(COMBINED_FLAGS "-Wall -Wno-unused-function -Wno-sign-compare -pedantic -D_GNU_SOURCE -Wno-nested-anon-types")
-    #if (APPLE AND NOT CMAKE_BUILD_TYPE MATCHES "Debug")
-    #    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
-    #    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -stdlib=libc++")
-    #endif()
-	set(CMAKE_CXX_FLAGS_RELEASE "-O3")
-	set(CMAKE_C_FLAGS_RELEASE "-O3")
+    set(CMAKE_CXX_FLAGS_RELEASE "-O3 -ffunction-sections -fdata-sections")
+    set(CMAKE_C_FLAGS_RELEASE "-O3 -ffunction-sections -fdata-sections")
+    if (APPLE)
+        set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} -Wl,-dead_strip")
+    else()
+        set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} -Wl,--gc-sections")
+    endif()
+
+    # use libc++ per default in MacOS
+    if (APPLE AND CMAKE_BUILD_TYPE MATCHES "Release")
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
+    endif()
+
+    #remove -rdynamic for Clang under Linux
+    if (UNIX AND IQTREE_FLAGS MATCHES "static")
+        SET(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS)
+    endif()
 elseif (CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
 	set(VCC "TRUE")
 	message("Compiler      : MS Visual C++ Compiler")
@@ -173,6 +189,15 @@
 	endif()
 endif()
 
+# enable link time optimization
+if (IQTREE_FLAGS MATCHES "lto")
+    #if (CLANG)
+    #    set(COMBINED_FLAGS "${COMBINED_FLAGS} -flto=thin")
+    #else()
+        set(COMBINED_FLAGS "${COMBINED_FLAGS} -flto")
+    #endif()
+endif()
+
 ##################################################################
 # configure MPI compilation
 ##################################################################
@@ -239,9 +264,11 @@
   		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /openmp")
   		include_directories("${PROJECT_SOURCE_DIR}/pll") # for PThreads headers
 	elseif (ICC)
-  		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Qopenmp")
   		if (WIN32)
+            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Qopenmp")
   			include_directories("${PROJECT_SOURCE_DIR}/pll") # for PThreads headers
+        else()
+            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -qopenmp")
   		endif()
   	elseif (GCC)
 		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread")
@@ -275,7 +302,7 @@
 	set(AVX_FLAGS "${AVX_FLAGS} -mavx -fabi-version=0")
 elseif (ICC)
 	if (WIN32)
-		 set(AVX_FLAGS "${AVX_FLAGS} /arch:AVX")
+		 set(AVX_FLAGS "${AVX_FLAGS} /arch:avx")
 	else()
 		 set(AVX_FLAGS "${AVX_FLAGS} -mavx")
 	endif()
@@ -288,7 +315,7 @@
 	set(SSE_FLAGS "${SSE_FLAGS} -msse3")
 elseif (ICC)
 	if (WIN32)
-		set(SSE_FLAGS "${SSE_FLAGS} /arch:SSE3")
+		set(SSE_FLAGS "${SSE_FLAGS} /arch:sse3")
 	else()
 		set(SSE_FLAGS "${SSE_FLAGS} -msse3")
 	endif()
@@ -303,7 +330,7 @@
 	set(FMA_FLAGS "${FMA_FLAGS} -mavx -fabi-version=0 -mfma")
 elseif (ICC) 
 	if (WIN32)
-		 set(FMA_FLAGS "${FMA_FLAGS} /arch:AVX /Qfma")
+		 set(FMA_FLAGS "${FMA_FLAGS} /arch:core-avx2")
 	else()
 		 set(FMA_FLAGS "${FMA_FLAGS} -march=core-avx2")
 	endif()
@@ -311,31 +338,3 @@
 
 SET(AVX512_FLAGS "-D__SSE3 -D__AVX")
 if (VCC)
-    message("AVX512 not available in Visual C++")
-	#set(AVX512_FLAGS "${AVX512_FLAGS} /arch:AVX512")
-elseif (CLANG)
-	set(AVX512_FLAGS "${AVX512_FLAGS} -mavx512f -mfma")
-elseif (GCC)
-	set(AVX512_FLAGS "${AVX512_FLAGS} -mavx512f -mfma")
-elseif (ICC) 
-	if (WIN32)
-		 set(AVX512_FLAGS "${AVX512_FLAGS} /arch:MIC-AVX512 /Qfma")
-	else()
-		 set(AVX512_FLAGS "${AVX512_FLAGS} -xMIC-AVX512 -mfma")
-	endif()
-endif()
-
-
-# further flag to improve performance
-
-if (IQTREE_FLAGS MATCHES "fma") # AVX+FMA instruction set
- 	message("Vectorization : AVX+FMA")
-	add_definitions(-D__SSE3 -D__AVX) # define both SSE3 and AVX directive
-    set(COMBINED_FLAGS "${COMBINED_FLAGS} ${FMA_FLAGS}")
-	#SET(EXE_SUFFIX "${EXE_SUFFIX}-fma")
-elseif (IQTREE_FLAGS MATCHES "avx") # AVX instruction set
- 	message("Vectorization : AVX")
-	add_definitions(-D__SSE3 -D__AVX) # define both SSE3 and AVX directive
-	set(COMBINED_FLAGS "${COMBINED_FLAGS} ${AVX_FLAGS}")
-	#SET(EXE_SUFFIX "${EXE_SUFFIX}-avx")
-elseif (NOT IQTREE_FLAGS MATCHES "nosse") #SSE intruction set

=== debian/changelog ===
iqtree (1.5.5+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Mon, 19 Jun 2017 08:58:16 +0200
